## python-ocp 7.8.1.2

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17 )
project( OCP
         LANGUAGES CXX )

if( NOT WIN32 )
    enable_language( C )
endif()

list( APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR} )

find_package (Python REQUIRED COMPONENTS Interpreter Development)
message( STATUS "Python lib: ${Python_LIBRARIES}" )

SET(PYTHON_SP_DIR "site-packages" CACHE PATH "Python site-packages directory (for installing)")

find_package( pybind11 REQUIRED )
find_package( VTK REQUIRED
  COMPONENTS
    WrappingPythonCore
    RenderingCore
    RenderingOpenGL2
    CommonDataModel
    CommonExecutionModel
    freetype
)
message(STATUS "VTK ${VTK_VERSION} found")
find_package( OpenCASCADE REQUIRED )

include_directories( ${PROJECT_SOURCE_DIR} )
file( GLOB CPP_FILES ${PROJECT_SOURCE_DIR}/*.cpp )

add_library( OCP MODULE ${CPP_FILES} )

target_include_directories( OCP PRIVATE ${OpenCASCADE_INCLUDE_DIR} )

target_link_libraries( OCP PRIVATE ${OpenCASCADE_LIBRARIES} )
target_link_libraries( OCP PRIVATE pybind11::pybind11 VTK::WrappingPythonCore VTK::RenderingCore VTK::CommonDataModel VTK::CommonExecutionModel)

set_target_properties( OCP
                       PROPERTIES
                       CXX_STANDARD 17
                       INTERPROCEDURAL_OPTIMIZATION FALSE
                       PREFIX "${PYTHON_MODULE_PREFIX}"
                       SUFFIX "${PYTHON_MODULE_EXTENSION}" )

if(WIN32)
  target_compile_options( OCP PRIVATE /bigobj )
  target_compile_definitions( OCP PRIVATE
                              "Standard_EXPORT="
                              "Standard_EXPORTEXTERN="
                              "Standard_EXPORTEXTERNC=extern \"C\""
                              "Standard_IMPORT=extern"
                              "Standard_IMPORTC=extern \"C\""
                              "_SILENCE_CXX17_ITERATOR_BASE_CLASS_DEPRECATION_WARNING")
  target_link_libraries( OCP PRIVATE opengl32 )
  target_link_libraries( OCP PRIVATE ${Python_LIBRARIES} )

else()
  set_target_properties( OCP
                         PROPERTIES
                         CMAKE_CXX_FLAGS_RELEASE "-O3 "
                         COMPILE_FLAGS "-fpermissive -fvisibility=hidden -fvisibility-inlines-hidden" )
endif()

if(UNIX AND NOT APPLE)
  target_link_options( OCP PRIVATE "LINKER:--allow-multiple-definition")
endif()

if(APPLE)
  target_link_libraries( OCP PRIVATE "-undefined dynamic_lookup")
endif()


install( TARGETS OCP LIBRARY DESTINATION ${PYTHON_SP_DIR} )

=== debian/changelog ===
python-ocp (7.8.1.2-1) experimental; urgency=medium

  * Initial packaging.

 -- Roland Mas <lolando@debian.org>  Sat, 02 Aug 2025 03:04:54 +0200

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_dwz:
	dh_dwz -- -L none

=== debian/watch ===
version=4
opts="mode=git, gitmode=full, pgpmode=none" \
https://github.com/CadQuery/OCP \
refs/tags/v?@ANY_VERSION@

## python-ocp 7.9.3.1%2B~cs7.9.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,7 @@
 
 SET(PYTHON_SP_DIR "site-packages" CACHE PATH "Python site-packages directory (for installing)")
 
+find_package( fmt  REQUIRED )
 find_package( pybind11 REQUIRED )
 find_package( VTK REQUIRED
   COMPONENTS
@@ -34,7 +35,7 @@
 target_include_directories( OCP PRIVATE ${OpenCASCADE_INCLUDE_DIR} )
 
 target_link_libraries( OCP PRIVATE ${OpenCASCADE_LIBRARIES} )
-target_link_libraries( OCP PRIVATE pybind11::pybind11 VTK::WrappingPythonCore VTK::RenderingCore VTK::CommonDataModel VTK::CommonExecutionModel)
+target_link_libraries( OCP PRIVATE pybind11::pybind11 VTK::WrappingPythonCore VTK::RenderingCore VTK::CommonDataModel VTK::CommonExecutionModel fmt::fmt)
 
 set_target_properties( OCP
                        PROPERTIES

## python-ocp 7.9.3.1+~cs7.9.3.1

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.29 )
project( OCP )

set( N_PROC 2 CACHE STRING "Number of processes used for generating code")
set( DLL_EXT dll CACHE STRING "DLL suffix")
set( MSVC_VER 16 CACHE STRING "MSVC version to download for win generation")
set( OCCT_LIB_DIR  CACHE PATH "Location of OCCT sos/dlls")

find_package( OpenGL REQUIRED )
find_package( LLVM REQUIRED )
find_package( VTK REQUIRED
  COMPONENTS
    CommonCore
    WrappingPythonCore
    RenderingCore
    RenderingOpenGL2
    CommonDataModel
    CommonExecutionModel
    freetype
)

message(STATUS "VTK ${VTK_VERSION} found")

find_package( RapidJSON REQUIRED )
find_package( Clang REQUIRED )

set( Python_FIND_VIRTUALENV FIRST )
find_package( Python COMPONENTS Interpreter Development REQUIRED )

# find OCCT and dump symbols
if( EXISTS ${OCCT_LIB_DIR})
    file(GLOB occt_libs LIST_DIRECTORIES false ${OCCT_LIB_DIR}/*.${DLL_EXT} )
    message(STATUS Found OCCT libs: ${occt_libs})
else()
    find_package( OpenCASCADE REQUIRED )

    foreach(target ${OpenCASCADE_LIBRARIES} )
        get_target_property(loc ${target} IMPORTED_LOCATION_RELEASE)
        list( APPEND occt_libs ${loc} )
    endforeach()
endif()

execute_process(
    COMMAND
    ${Python_EXECUTABLE}
    ${CMAKE_SOURCE_DIR}/dump_symbols.py
    "${occt_libs}"
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

get_target_property( LIBCLANG_PATH libclang IMPORTED_LOCATION_RELEASE )
get_target_property( VTK_INCLUDE_DIR VTK::CommonCore INTERFACE_INCLUDE_DIRECTORIES )

# for some reason I get multiple generator expressions
string(REPLACE ">" ">;" VTK_INCLUDE_DIR ${VTK_INCLUDE_DIR})
list(GET VTK_INCLUDE_DIR 0 VTK_INCLUDE_DIR)

message( STATUS "Include dirs: ${VTK_INCLUDE_DIR}")
message( STATUS "Include dirs: ${CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES}")

# OSX
if(${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
    list( APPEND CXX_INCLUDES -i /opt/usr/local/include/c++/v1/ -i /opt/usr/local/include/ )

# Linux-like
elseif(NOT PLATFORM STREQUAL "Windows")
    foreach( inc IN LISTS CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES)
        list( APPEND CXX_INCLUDES -i ${inc}/ )
    endforeach()

# X-generation from Linux to Windows
else()
    # download part of msvc 16 and winsdk
    if( NOT EXISTS ${CMAKE_BINARY_DIR}/msvc )
        execute_process(
            COMMAND
            ${Python_EXECUTABLE}
            ${CMAKE_SOURCE_DIR}/extern/msvc-wine/vsdownload.py
            --major ${MSVC_VER}
            --accept-license
            --dest msvc
            Win10SDK_10.0.19041
            Microsoft.VisualCpp.CRT.Headers
            WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        )
    endif()

    list( APPEND CXX_INCLUDES -i ${CMAKE_BINARY_DIR}/msvc/VC/Tools/MSVC/14.29.30133/include )
    list( APPEND CXX_INCLUDES -i ${CMAKE_BINARY_DIR}/msvc/Windows\ Kits/10/Include/10.0.19041.0/ucrt/ )
    list( APPEND CXX_INCLUDES -i ${CMAKE_SOURCE_DIR}/extern/include/ )
endif()

if(PLATFORM)
    message( STATUS "Requested platform: ${PLATFORM}")
else()
    message( STATUS "Platform not specified.")

    if(${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
        set(PLATFORM Windows)
    elseif(${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
        set(PLATFORM OSX)
    else()
        set(PLATFORM Linux)
    endif()
endif()

set(ENV{PYTHONPATH} ${CMAKE_SOURCE_DIR}/pywrap )

add_custom_command(
    OUTPUT ${CMAKE_BINARY_DIR}/OCP/CMakeLists.txt
    COMMAND
        ${CMAKE_COMMAND} -E env "PYTHONPATH=${CMAKE_SOURCE_DIR}/pywrap"
        ${Python_EXECUTABLE}
        -m bindgen
        -n ${N_PROC}
        -l ${LIBCLANG_PATH}
        -i ${VTK_INCLUDE_DIR}/
        -i ${OPENGL_INCLUDE_DIRS}
        -i ${RapidJSON_INCLUDE_DIRS}
        -i ${CLANG_INSTALL_PREFIX}/lib/clang/${LLVM_VERSION_MAJOR}/include/
        -p ${CMAKE_SOURCE_DIR}
        ${CXX_INCLUDES}
        all ${CMAKE_SOURCE_DIR}/ocp.toml ${PLATFORM}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    DEPENDS ${CMAKE_SOURCE_DIR}/ocp.toml
    USES_TERMINAL
    COMMENT "Running pywrap"
)

add_custom_target(pywrap ALL DEPENDS ${CMAKE_BINARY_DIR}/OCP/CMakeLists.txt )

=== debian/changelog ===
python-ocp (7.9.3.1+~cs7.9.3.1-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Sun, 01 Mar 2026 19:52:55 +0100

python-ocp (7.9.3.0+~cs7.8.1.2-1) unstable; urgency=medium

  * Add missing Build-Depends.
  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Sun, 15 Feb 2026 18:43:11 +0100

python-ocp (7.8.1.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Roland Mas <lolando@debian.org>  Tue, 12 Aug 2025 15:48:49 +0200

=== debian/control ===
Source: python-ocp
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>,
 Roland Mas <lolando@debian.org>,
Section: python
Priority: optional
Build-Depends:
 clang,
 cmake,
 debhelper-compat (= 13),
 libclang-dev,
 libedit-dev,
 libfmt-dev,
 libfreetype-dev,
 libocct-data-exchange-dev,
 libocct-draw-dev,
 libocct-foundation-dev,
 libocct-ivtk-dev,
 libocct-modeling-algorithms-dev,
 libocct-modeling-data-dev,
 libocct-ocaf-dev,
 libocct-visualization-dev,
 libvtk9-dev,
 llvm-dev,
 python3-all,
 python3-clang,
 python3-freetype,
 python3-opencascade-pywrap,
 python3-pybind11,
 rapidjson-dev,
 tk-dev,
Standards-Version: 3.9.6
Testsuite: autopkgtest-pkg-pybuild
Homepage: https://github.com/CadQuery/OCP
Vcs-Git: https://salsa.debian.org/python-team/packages/python-ocp.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/python-ocp

Package: python3-ocp
Architecture: any
Depends:
 python3,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python wrapper for OCCT generated using pywrap
 Goals:
  * Provide thin bindings to OCCT.
  * Wrap all OCCT modules (if practical).
  * React quickly to new OCCT releases.
  * Cater primarily for the CadQuery project.

=== debian/rules ===
#!/usr/bin/make -f

export CC=clang
export CXX=clang++

%:
	dh $@

override_dh_dwz:
	# dh_dwz -- -L none # Fails with Unknown debugging section .debug_addr

ifneq (,$(DEB_BUILD_OPTION_PARALLEL))
  PARALLEL=$(DEB_BUILD_OPTION_PARALLEL)
else
  PARALLEL=$$(nproc)
endif

override_dh_auto_configure:
	dh_auto_configure -- -DN_PROC=$(PARALLEL)

=== debian/watch ===
version=4
opts="mode=git, gitmode=full, pgpmode=none" \
https://github.com/CadQuery/OCP \
refs/tags/v?@ANY_VERSION@ group

opts=\
component=OCP,searchmode=plain \
https://api.github.com/repos/CadQuery/OCP/releases https://github.com/CadQuery/OCP/releases/download/@ANY_VERSION@/OCP_src_stubs_Linux.zip checksum
